<?php
require_once 'common.inc.php';

$pop3 = new cMyPop3;
$pop3->connect();
$pop3->login();

if ( !isset( $_SESSION)) {
  $_SESSION[ 'showMailIndex'] = 0;
}
if ( isset( $_GET[ 'showMailIndex'])) {
  $_SESSION[ 'showMailIndex'] = $_GET[ 'showMailIndex'];
}

$showNum = $config[ 'mua'][ 'showList'];
$mailNum = $pop3->numMsg();
$showMailIndex = isset( $_SESSION[ 'showMailIndex'])? $_SESSION[ 
'showMailIndex']: 1;
$start = $showMailIndex * $showNum;
$end = $start + $showNum < $mailNum? $start + $showNum: $mailNum;

html_header();
toolbar();
show_mail_list( &$pop3, $start, $end, $showMailIndex, $showNum, $mailNum);
if ( isset( $_GET[ 'showMail'])) {
  show_mail( &$pop3, $_GET[ 'showMail']);
}

function show_mail_list( &$pop3, $start, $end, $showMailIndex, $showNum, 
$mailNum) {
  global $PHP_SELF;
  global $config;
  $showCharSet = $config[ 'mua'][ 'showCharSet'];
  $mailCharSet = $config[ 'mua'][ 'mailCharSet'];
  for ( $i = 0; $i < $mailNum / $showNum; $i++) {
    $pager .= <<<EOD
  <a href="$PHP_SELF?showMailIndex=$i">[$i]</a>

EOD;
  }
  print <<<EOD
<h2>᡼</h2><br>
<div>
  ᡼:$mailNum<br>
$pager
</div>
<div>
  <table border="1" width="100%">
  <tr><th>#</th><th>̾</th><th></th><th>п</th><th></th></tr>
EOD;
  for ( $i = $start + 1; $i <= $end; $i++) {
    $headers = mb_decode_mimeheaders( $pop3->getParsedHeaders( $i), 
$showCharSet);
    $Subject = htmlspecialchars( $headers[ 'Subject']);
    foreach ( array( 'To', 'From') as $name) {
     $$name = isset( $headers[ $name])?
      htmlspecialchars( mail_header_join( $headers[ $name], ',')): '';
    }
    $date = htmlspecialchars( mail_header_date( $headers[ 'Date']));
    print <<<EOD
  <tr>
   <td><a href="$PHP_SELF?showMailIndex=$showMailIndex&showMail=$i">$i</a></td>
   <td>$Subject</td><td>$To</td><td>$From</td><td>$date</td></tr>
EOD;
  }
  print <<<EOD
  </table>
</div>
EOD;
}

function show_mail( &$pop3, $msg_id) {
  global $config;

  $showCharSet = $config[ 'mua'][ 'showCharSet'];
  $mailCharSet = $config[ 'mua'][ 'mailCharSet'];
  $params['include_bodies'] = true;
  $params['decode_bodies']  = false;
  $params['decode_headers'] = false;
  $params['input'] = $pop3->getMsg( $msg_id);
  $params['crlf'] = "\r\n";
  //  MIME᡼Υǥɽ
  $mailObj = Mail_mimeDecode::decode( $params);
  //  MIMEإåν
  $headers = mb_decode_mimeheaders( $mailObj->headers, $showCharSet);
  $subject = htmlspecialchars( $headers[ 'subject']);
  foreach ( array( 'to', 'cc', 'from') as $name) {
    $$name = isset( $headers[ $name])?
     htmlspecialchars( mail_header_join( $headers[ $name], ',')): '';
  }
  $date = htmlspecialchars( mail_header_date( $headers[ 'date']));
  if ( isset( $mailObj->parts)) {
    // MIMEѡȤ᡼
    $body = '';
    $attachs = array();
    foreach ( $mailObj->parts as $index=>$parts) {
      if ( $parts->ctype_primary == 'text') {
        $charSet = $parts->ctype_parameters[ 'charset'];
        $body .= mb_convert_encoding( $parts->body, $showCharSet, $charSet);
      } else {
        $attachs[] = <<<EOD
<a href="download_attach.php?showMail=$msg_id&attach=$index" 
target="_new">{$parts->d_parameters[ 'filename']}</a>
EOD;
      }
    }
    $attach = implode( ' ', $attachs);
  } else {
    //  ̾Υ᡼
    $contentType = $headers[ 'content-type'];
    if ( eregi( "charset=['\"]?([a-z0-9\-]+)['\"]?", $contentType, $eregarr)) {
      $content_type = $eregarr[ 1];
      $body = mb_convert_encoding( $mailObj->body, 'euc-jp', $content_type);
    } else {
      $body = $mailObj->body;
    }
    $attach = '';
  }
  $body = nl2br( htmlspecialchars( $body));
  print <<<EOD
<h2>᡼ɽ</h2>
<div>
  <table border="1" width="100%">
  <tr><th colspan="2">إå</th></tr>
  <tr><th>̾:</th><td>$subject</td></tr>
  <tr><th>п:</th><td>$from</td></tr>
  <tr><th>:</th><td>$to</td></tr>
  <tr><th>Cc:</th><td>$cc</td></tr>
  <tr><th>:</th><td>$date</td></tr>
  <tr><th colspan="2">ź</th></tr>
  <tr><td colspan="2">$attach</td></tr>
  <tr><th colspan="2">ʸ</th></tr>
  <tr><td colspan="2">$body</td></tr>
  </table>
</div>
EOD;
}

$html_footer();

?>
